<template lang="html">
  <div class="butter-table">
    <flex dir="column">
      <flex dir="row">
        <span v-for="(label, key) in header" class="header cell" :class="`span${label.span}`">{{ label.value }}</span>
      </flex>
      <flex dir="row" v-for="(row, i) in data" :key="i" :class="theme">
        <span v-for="(cell, ii) in row" :key="ii" class="cell" :class="`span${cell.span}`"><a v-if="cell.href" :href="cell.href">{{ cell.value }}</a><template v-else>{{ cell.value }}</template></span>
      </flex>
    </flex>
    <pagination :page="page" :pages="pages" @paginate="fetchPage" />
  </div>
</template>

<script>
export default {
  props: ['data','header','page','pages','theme'],
  methods: {
    fetchPage(event) {
      this.$emit('paginate', event);
    },
  },
}
</script>

<style lang="scss" scoped>
@import 'butter-themes';
@import 'butter-mixins';
  .butter-table {
    @include flex($dir: column, $grow: 0, $shrink: 1);
    margin-top: $grid*2;
  }
  .cell {
    @include themify($themes) {
      color: themed('color-text-tertiary');
      border-bottom: 1px solid themed('border-color');
    }
    @include font(16px,24px,$font-sans);
    padding: $grid*3 $grid*1.5;
    display: flex;
    flex: 1 1 0;
    word-break: break-all;
    .mono & {
      @include font(14px,24px,$font-mono);
    }

    &.span2 {
      flex-grow: 2;
    }
    &.span3 {
      flex-grow: 3;
    }
    &.span4 {
      flex-grow: 4;
    }
    &.span5 {
      flex-grow: 5;
    }
    &.span6 {
      flex-grow: 6;
    }
  }
  .header.cell {
    @include themify($themes) {
      color: themed('color-text-primary');
    }
    @include font(18px,24px,$font-sans-bold);
    border-bottom: none;
    padding: 0 $grid*1.5;
  }
</style>
